MONGOSTAT(1)

NAME
mongostat - MongoDB Use Statistics

  On this page

•   Synopsis

•   Availability

•   Required Access

•   Behavior

•   Options

•   Fields

•   Examples

•   Additional Information

macOS Sierra and Go 1.6 Incompatibility

    Users running on macOS Sierra require the 3.2.10 or newer version of mongostat.

SYNOPSIS

The mongostat utility provides a quick overview of the status of a currently running mongod or mongos instance. mongostat is functionally similar to the UNIX/Linux file system utility vmstat, but provides data regarding mongod and mongos instances.

Run mongostat from the system command line, not the mongo shell.

AVAILABILITY

The mongostat tool is part of the MongoDB tools package. Consult the installation guide for your platform for instructions on how to install the tools package as part of your MongoDB installation.

The tools package is also available from the MongoDB Download Center, either as a separate tools download, or contained within the TGZ or ZIP downloads, depending on platform. On Windows, the MSI installer includes all tools as part of the default installation.

TIP

If downloading the TGZ or ZIP files from the Download Center, you may want to update your PATH environment variable to include the directory where you installed these tools. See the installation guide for your platform for more information.

REQUIRED ACCESS

In order to connect to a mongod that enforces authorization with the --auth option, specify the --username and --password options, and the connecting user must have the serverStatus privilege action on the cluster resources.

The built-in role clusterMonitor provides this privilege as well as other privileges. To create a role with just the privilege to run mongostat, see create-role-for-mongostat.

BEHAVIOR

  FIPS

Starting in version 4.2, MongoDB removes the --sslFIPSMode option for mongostat. mongostat will use FIPS compliant connections to mongod/mongos if the mongod/mongos instances are configured to use FIPS mode.

OPTIONS

mongostat

--help
    Returns information on the options and use of mongostat.

--verbose, -v
    Increases the amount of internal reporting returned on standard output or in log files. Increase the verbosity with the -v form by including the option multiple times, (e.g. -vvvvv.)

--version
    Returns the mongostat release number.

--uri=<connectionString>
    New in version 3.4.6.

    Specify a resolvable URI connection string (enclose in quotes) to connect to the MongoDB deployment.

    --uri="mongodb://[username:password@]host1[:port1][,host2[:port2],...[,hostN[:portN]]][/[database][?options]]"

    For information on the components of the connection string, see the Connection String URI Format documentation.

    NOTE: For TLS/SSL options, use the command-line options instead of the URI options for TLS/SSL (Available starting in 4.2).

    IMPORTANT: The following command-line options cannot be used in conjunction with --uri option:

•   --host

•   --port

•   --username

•   --password (if the URI connection string also includes the password)

•   --authenticationDatabase

•   --authenticationMechanism

    Instead, specify these options as part of your --uri connection string.

--host=<hostname><:port>, -h=<hostname><:port>
    Default: localhost:27017

    Specifies a resolvable hostname for the mongod to which to connect. By default, the mongostat attempts to connect to a MongoDB instance running on the localhost on port number 27017.

    To connect to a replica set, you can specify the set member or members to report on, as in the following (see also the --discover flag):

    --host=<hostname1><:port>,<hostname2><:port>,<...>

    Changed in version 3.0.0: If you use IPv6 and use the <address>:<port> format, you must enclose the portion of an address and port combination in brackets (e.g. [<address>]).

    NOTE: You cannot specify both --host and --uri.

--port=<port>
    Default: 27017

    Specifies the TCP port on which the MongoDB instance listens for client connections.

    NOTE: You cannot specify both --port and --uri.

--ipv6
    Removed in version 3.0.

    Enables IPv6 support and allows mongostat to connect to the MongoDB instance using an IPv6 network. Prior to MongoDB 3.0, you had to specify --ipv6 to use IPv6. In MongoDB 3.0 and later, IPv6 is always enabled.

--ssl
    New in version 2.6.

    Enables connection to a mongod or mongos that has TLS/SSL support enabled.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslCAFile=<filename>
    New in version 2.6.

    Specifies the .pem file that contains the root certificate chain from the Certificate Authority. Specify the file name of the .pem file using relative or absolute paths.

    Starting in version 3.4, if --tlsCAFile/net.tls.CAFile (or their aliases --sslCAFile/net.ssl.CAFile) is not specified and you are not using x.509 authentication, the system-wide CA certificate store will be used when connecting to an TLS/SSL-enabled server.

    To use x.509 authentication, --tlsCAFile or net.tls.CAFile must be specified unless using --tlsCertificateSelector or --net.tls.certificateSelector. Or if using the ssl aliases, --sslCAFile or net.ssl.CAFile must be specified unless using --sslCertificateSelector or net.ssl.certificateSelector.

    WARNING: Version 3.2 and earlier: For TLS/SSL connections (--ssl) to mongod and mongos, if the mongostat runs without the --sslCAFile, mongostat will not attempt to validate the server certificates. This creates a vulnerability to expired mongod and mongos certificates as well as to foreign processes posing as valid mongod or mongos instances. Ensure that you always specify the CA file to validate the server certificates in cases where intrusion is a possibility.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslPEMKeyFile=<filename>
    New in version 2.6.

    Specifies the .pem file that contains both the TLS/SSL certificate and key. Specify the file name of the .pem file using relative or absolute paths.

    This option is required when using the --ssl option to connect to a mongod or mongos that has CAFile enabled without allowConnectionsWithoutCertificates.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslPEMKeyPassword=<value>
    New in version 2.6.

    Specifies the password to de-crypt the certificate-key file (i.e. --sslPEMKeyFile). Use the --sslPEMKeyPassword option only if the certificate-key file is encrypted. In all cases, the mongostat will redact the password from all logging and reporting output.

    If the private key in the PEM file is encrypted and you do not specify the --sslPEMKeyPassword option, the mongostat will prompt for a passphrase. See ssl-certificate-password.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslCRLFile=<filename>
    New in version 2.6.

    Specifies the .pem file that contains the Certificate Revocation List. Specify the file name of the .pem file using relative or absolute paths.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslAllowInvalidCertificates
    New in version 2.6.

    Bypasses the validation checks for server certificates and allows the use of invalid certificates. When using the allowInvalidCertificates setting, MongoDB logs as a warning the use of the invalid certificate.

    Starting in MongoDB 4.0, if you specify --sslAllowInvalidCertificates or net.ssl.allowInvalidCertificates: true (or in MongoDB 4.2, the alias --tlsAllowInvalidateCertificates or net.tls.allowInvalidCertificates: true) when using x.509 authentication, an invalid certificate is only sufficient to establish a TLS/SSL connection but is insufficient for authentication.

    WARNING: Although available, avoid using the --sslAllowInvalidCertificates option if possible. If the use of --sslAllowInvalidCertificates is necessary, only use the option on systems where intrusion is not possible.

    If the mongo shell (and other mongodb-tools-support-ssl) runs with the --sslAllowInvalidCertificates option, the mongo shell (and other mongodb-tools-support-ssl) will not attempt to validate the server certificates. This creates a vulnerability to expired mongod and mongos certificates as well as to foreign processes posing as valid mongod or mongos instances. If you only need to disable the validation of the hostname in the TLS/SSL certificates, see --sslAllowInvalidHostnames.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--sslAllowInvalidHostnames
    New in version 3.0.

    Disables the validation of the hostnames in TLS/SSL certificates. Allows mongostat to connect to MongoDB instances even if the hostname in their certificates do not match the specified hostname.

    For more information about TLS/SSL and MongoDB, see /tutorial/configure-ssl and /tutorial/configure-ssl-clients .

--username=<username>, -u=<username>
    Specifies a username with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --password and --authenticationDatabase options.

    NOTE: You cannot specify both --username and --uri.

--password=<password>, -p=<password>
    Specifies a password with which to authenticate to a MongoDB database that uses authentication. Use in conjunction with the --username and --authenticationDatabase options.

    Changed in version 3.0.2: To prompt the user for the password, pass the --username option without --password or specify an empty string as the --password value, as in --password="" .

    NOTE: You cannot specify both --password and --uri.

--authenticationDatabase=<dbname>
    Specifies the authentication database where the specified --username has been created. See user-authentication-database.

    NOTE: You cannot specify both --authenticationDatabase and --uri.

    --authenticationDatabase is required for mongod and mongos instances that use authentication.

--authenticationMechanism=<name>
    Default: SCRAM-SHA-1

    Specifies the authentication mechanism the mongostat instance uses to authenticate to the mongod or mongos.

    Changed in version 4.0: MongoDB removes support for the deprecated MongoDB Challenge-Response (MONGODB-CR) authentication mechanism.

    MongoDB adds support for SCRAM mechanism using the SHA-256 hash function (SCRAM-SHA-256).
    Value | Description
    SCRAM-SHA-1 | RFC 5802 standard Salted Challenge Response Authentication Mechanism using the SHA-1 hash function.
    SCRAM-SHA-256 | RFC 7677 standard Salted Challenge Response Authentication Mechanism using the SHA-256 hash function. Requires featureCompatibilityVersion set to 4.0. New in version 4.0.
    MONGODB-X509 | MongoDB TLS/SSL certificate authentication.
    GSSAPI (Kerberos) | External authentication using Kerberos. This mechanism is available only in MongoDB Enterprise.
    PLAIN (LDAP SASL) | External authentication using LDAP. You can also use PLAIN for authenticating in-database users. PLAIN transmits passwords in plain text. This mechanism is available only in MongoDB Enterprise.

    NOTE: You cannot specify both --authenticationMechanism and --uri.

--gssapiServiceName=<string>
    New in version 2.6.

    Specify the name of the service using GSSAPI/Kerberos. Only required if the service does not use the default name of mongodb.

    This option is available only in MongoDB Enterprise.

--gssapiHostName=<string>
    New in version 2.6.

    Specify the hostname of a service using GSSAPI/Kerberos. Only required if the hostname of a machine does not match the hostname resolved by DNS.

    This option is available only in MongoDB Enterprise.

--humanReadable=<boolean>
    Default: True

    New in version 3.4.

    When true, mongostat formats dates and quantity values for easier reading, as in the following sample output:

    insert query update delete getmore command dirty used flushes vsize  res qrw arw net_in net_out conn                time
       991    *0     *0     *0       0     2|0  3.4% 4.5%       0 2.90G 297M 0|0 0|0  12.9m   84.2k    2 Oct  6 09:45:37.478
       989    *0     *0     *0       0     2|0  3.6% 4.7%       0 2.91G 310M 0|0 0|0  12.9m   84.1k    2 Oct  6 09:45:38.476
       988    *0     *0     *0       0     1|0  3.7% 4.8%       0 2.92G 323M 0|0 0|0  12.8m   83.8k    2 Oct  6 09:45:39.481
       976    *0     *0     *0       0     2|0  3.9% 5.0%       0 2.94G 335M 0|0 0|0  12.7m   83.7k    2 Oct  6 09:45:40.476

    When false, mongostat returns the raw data, as in the following sample output:

    insert query update delete getmore command dirty used flushes      vsize       res qrw arw   net_in net_out conn                      time
       992    *0     *0     *0       0     2|0   1.3  2.4       0 2941255680 149946368 0|0 0|0 12913607   84271    2 2016-10-06T09:45:25-04:00
       989    *0     *0     *0       0     1|0   1.5  2.6       0 2974810112 163577856 0|0 0|0 12873225   84087    2 2016-10-06T09:45:26-04:00
       996    *0     *0     *0       0     1|0   1.6  2.8       0 2972712960 177209344 0|0 0|0 12955423   84345    2 2016-10-06T09:45:27-04:00
       987    *0     *0     *0       0     1|0   1.8  2.9       0 2989490176 190840832 0|0 0|0 12861852   84008    2 2016-10-06T09:45:28-04:00

-o=<field list>
    New in version 3.4.

    When specified, mongostat includes only the specified fields in the mongostat output.

    Use dot notation to specify serverStatus fields, as in metrics.document.inserted.

    To specify a custom name for a field, use <field>=<customName>, as in:

    mongostat -o='host=H,time=T,version=MongoDB Version'

    -o supports the following methods to modify the information returned for a given serverStatus field:

rate()
    Use .rate() to view the rate per second at which a serverStatus field is changing from mongostat call to call.

    View Rate of Change for a Field with .rate() illustrates how to use mongostat with -o and the .rate() method.

diff()
    Use .diff() to view how much a serverStatus field has changed since the previous mongostat call. The interval between calls is specified by <sleeptime>.

    View Field Changes with .diff() illustrates how to use mongostat with -o and the .diff() method.

    mongostat supports specifying either -o or -O: you cannot include both options.

    See Specify mongostat Output Fields for an example of -o.

-O=<field list>
    New in version 3.4.

    When specified, mongostat includes the specified serverStatus fields after the default mongostat output.

    Use dot notation to specify serverStatus fields, as in metrics.document.inserted.

    To specify a custom name for a field, use <field>=<customName>, as in:

    mongostat -O=host=H,time=T

    mongostat supports specifying either -O or -o: you cannot include both options.

    See Add Fields to mongostat Output for an example of -O.

--noheaders
    Disables the output of column or field names.

--rowcount=<number>, -n=<number>
    Controls the number of rows to output. Use in conjunction with the sleeptime argument to control the duration of a mongostat operation.

    Unless --rowcount is specified, mongostat will return an infinite number of rows (e.g. value of 0.)

--discover
    Discovers and reports on statistics from all members of a replica set or sharded cluster. When connected to any member of a replica set, --discover all non-hidden members of the replica set. When connected to a mongos, mongostat will return data from all shards in the cluster. If a replica set provides a shard in the sharded cluster, mongostat will report on non-hidden members of that replica set.

    The mongostat --host option is not required but potentially useful in this case.

    Changed in version 2.6: When running with --discover, mongostat now respects --rowcount.

--http
    Configures mongostat to collect data using the HTTP interface rather than a raw database connection.

    Changed in version 3.6: MongoDB 3.6 removes the deprecated HTTP interface and REST API to MongoDB.

--all
    Configures mongostat to return all optional fields.

--json
    New in version 3.0.0.

    Returns output for mongostat in JSON format.

--interactive
    New in version 3.4.

    Display mongostat output in an interactive non-scrolling interface rather than the default scrolling output.

    --interactive is not available with the --json option.

    See: View Statistics in an Interactive Interface for an example of --interactive.

<sleeptime>
    Default: 1

    The final mongostat argument is the length of time, in seconds, that mongostat waits in between calls. By default mongostat returns one call every second.

    mongostat returns values that reflect the operations over a 1 second period. For values of <sleeptime> greater than 1, mongostat averages data to reflect average operations per second.

FIELDS

mongostat returns values that reflect the operations over a 1 second period. When mongostat <sleeptime> has a value greater than 1, mongostat averages the statistics to reflect average operations per second.

mongostat outputs the following fields:

inserts
    The number of objects inserted into the database per second. If followed by an asterisk (e.g. *), the datum refers to a replicated operation.

query
    The number of query operations per second.

update
    The number of update operations per second.

delete
    The number of delete operations per second.

getmore
    The number of get more (i.e. cursor batch) operations per second.

command
    The number of commands per second. On secondary systems, mongostat presents two values separated by a pipe character (e.g. |), in the form of local|replicated commands.

flushes
    Changed in version 3.0.

    For the storage-wiredtiger, flushes refers to the number of WiredTiger checkpoints triggered between each polling interval.

dirty
    New in version 3.0.

    Only for storage-wiredtiger. The percentage of the WiredTiger cache with dirty bytes, calculated by wiredTiger.cache.tracked dirty bytes in the cache / wiredTiger.cache.maximum bytes configured.

used
    New in version 3.0.

    Only for storage-wiredtiger. The percentage of the WiredTiger cache that is in use, calculated by wiredTiger.cache.bytes currently in the cache / wiredTiger.cache.maximum bytes configured.

vsize
    The amount of virtual memory in megabytes used by the process at the time of the last mongostat call.

res The amount of resident memory in megabytes used by the process at the time of the last mongostat call.

locked
    Changed in version 3.0: Only appears when mongostat runs against pre-3.0 versions of MongoDB instances.

    The percent of time in a global write lock.

qr  The length of the queue of clients waiting to read data from the MongoDB instance.

qw  The length of the queue of clients waiting to write data from the MongoDB instance.

ar  The number of active clients performing read operations.

aw  The number of active clients performing write operations.

netIn
    The amount of network traffic, in bytes, received by the MongoDB instance.

    This includes traffic from mongostat itself.

netOut
    The amount of network traffic, in bytes, sent by the MongoDB instance.

    This includes traffic from mongostat itself.

conn
    The total number of open connections.

set The name, if applicable, of the replica set.

repl
    The replication status of the member.
    Value | Replication Type
    M | master
    SEC | secondary
    REC | recovering
    UNK | unknown
    RTR | mongos process ("router")
    ARB | arbiter

EXAMPLES

  Specify mongostat Collection Period and Frequency

In the first example, mongostat will return data every second for 20 seconds. mongostat collects data from the mongod instance running on the localhost interface on port 27017. All of the following invocations produce identical behavior:

mongostat --rowcount=20 1
mongostat --rowcount=20
mongostat -n=20 1
mongostat -n=20

In the next example, mongostat returns data every 5 minutes (or 300 seconds) for as long as the program runs. mongostat collects data from the mongod instance running on the localhost interface on port 27017. The following invocations produce identical behavior:

mongostat --rowcount=0 300
mongostat -n=0 300
mongostat 300

In the following example, mongostat returns data every 5 minutes for an hour (12 times.) mongostat collects data from the mongod instance running on the localhost interface on port 27017. The following invocations produce identical behavior:

mongostat --rowcount=12 300
mongostat -n=12 300

  Add Fields to mongostat Output

New in version 3.4.

-O allows you to specify fields from serverStatus output to add to the default mongostat output. The following example adds the host and version fields as well as the network.numRequests field, which will display as "network requests", to the default mongostat output:

mongostat -O='host,version,network.numRequests=network requests'

The mongostat output would then resemble:

insert query update delete getmore command dirty used flushes vsize   res qrw arw net_in net_out conn                time            host version network requests
    *0    *0     *0     *0       0     2|0  0.0% 0.0%       0 2.51G 19.0M 0|0 0|0   158b   39.4k    2 Oct 11 12:14:45.878 localhost:37017  3.3.14               91
    *0    *0     *0     *0       0     1|0  0.0% 0.0%       0 2.51G 19.0M 0|0 0|0   157b   39.3k    2 Oct 11 12:14:46.879 localhost:37017  3.3.14               95
    *0    *0     *0     *0       0     1|0  0.0% 0.0%       0 2.51G 19.0M 0|0 0|0   157b   39.2k    2 Oct 11 12:14:47.884 localhost:37017  3.3.14               99

  Specify mongostat Output Fields

New in version 3.4.

-o specifies the columns mongostat includes in its output. You can specify any serverStatus field as a mongostat output column. The following example specifies the host, time, and metrics.document.inserted fields:

mongostat -o='host,time,metrics.document.inserted'

The mongostat output would then resemble:

           host                time metrics.document.inserted
localhost:37017 Oct 11 12:21:17.370                         0
localhost:37017 Oct 11 12:21:18.371                         0
localhost:37017 Oct 11 12:21:19.371                         0
localhost:37017 Oct 11 12:21:20.368                         0

  View Rate of Change for a Field with .rate()

New in version 3.4.

.rate() enables you to view the rate per second at which a numerical field has changed from one mongostat call to the next. For example, you can view the rate at which documents have been inserted during an insert operation. .rate() can therefore help you view the performance of your mongod instance.

The following example reports on the rate of change of the metrics.document.inserted serverStatus field. The invocation uses -o's ability to specify the name of an column to label metrics.document.inserted.rate() as "inserted rate" and metrics.document.inserted as "inserted":

mongostat -o='host,mem,bits,metrics.document.inserted.rate()=inserted rate,metrics.document.inserted=inserted' --rowcount=5

The output would then resemble:

           host mem.bits inserted rate inserted
localhost:37017       64           501     3455
localhost:37017       64           967    13128
localhost:37017       64           972    22851
localhost:37017       64           214    25000
localhost:37017       64             0    25000

  View Field Changes with .diff()

New in version 3.4.

.diff() returns the difference between the current serverStatus field value and the value from the previous mongostat call. The following example returns statistics on the number of documents being inserted into a collection: inserted diff is the difference in the metrics.document.inserted field between subsequent calls, while inserted is the value of metrics.document.inserted:

mongostat -o='host,mem.bits,metrics.document.inserted.diff()=inserted diff,metrics.document.inserted=inserted' --rowcount=5

The output would then resemble:

           host mem.bits inserted diff inserted
localhost:27017       64             0    25359
localhost:27017       64            94    25453
localhost:27017       64           938    26391
localhost:27017       64           964    27355
localhost:27017       64           978    28333

  View Statistics for a Replica Set or Sharded Cluster

In many cases, using the --discover option will help provide a more complete snapshot of the state of an entire group of machines. If a mongos process connected to a sharded cluster is running on port 27017 of the local machine, you can use the following form to return statistics from all members of the cluster:

mongostat --discover

  View Statistics in an Interactive Interface

New in version 3.4.

Use the --interactive option to view statistics in a non-scrolling ncurses -style interactive output. The --interactive option lets you highlight specific hosts, columns, or fields to view. When combined with --discover, --interactive displays statistics for all members of a replica set or sharded cluster, as in the following example:

mongostat --discover --interactive

The output for a sharded cluster would then resemble:

                  host insert query update delete getmore command dirty used flushes mapped vsize   res faults qrw arw net_in net_out conn set repl                time
hostname.local:27018     *0    *0     *0     *0       0     1|0  0.0% 0.0%       0        3.25G 25.0M    n/a 0|0 1|0   157b   43.9k   19 tic  PRI Nov  2 11:44:46.439
hostname.local:27019     *0    *0     *0     *0       0     2|0  0.0% 0.0%       0        3.18G 26.0M    n/a 0|0 1|0   322b   44.4k   12 tic  SEC Nov  2 11:44:46.439
hostname.local:27020     *0    *0     *0     *0       0     2|0  0.0% 0.0%       0        3.18G 26.0M    n/a 0|0 1|0   322b   44.4k   12 tic  SEC Nov  2 11:44:46.439
hostname.local:27021   2017    *0     *0     *0     826  1029|0  0.0% 0.0%       0        3.25G 31.0M    n/a 0|0 1|0  1.74m   1.60m   20 tac  PRI Nov  2 11:44:46.439
hostname.local:27022  *2021    *0     *0     *0       0     2|0  0.0% 0.0%       0        3.19G 32.0M    n/a 0|0 1|0   322b   44.6k   12 tac  SEC Nov  2 11:44:46.438
hostname.local:27023  *2022    *0     *0     *0       0     3|0  0.0% 0.0%       0        3.19G 33.0M    n/a 0|0 1|0   323b   44.7k   12 tac  SEC Nov  2 11:44:46.438
     localhost:27017   2071    *0     *0     *0       0  2073|0                  0     0B 2.43G 9.00M      0 0|0 0|0   249k    130k    4      RTR Nov  2 11:44:47.429
Press '?' to toggle help

ADDITIONAL INFORMATION

For more information about monitoring MongoDB, see /administration/monitoring.

For more background on other MongoDB status outputs see:

•   /reference/command/serverStatus

•   /reference/command/replSetGetStatus

•   /reference/command/dbStats

•   /reference/command/collStats

    For an additional utility that provides MongoDB metrics see mongotop.

AUTHOR
MongoDB Documentation Project

COPYRIGHT
2008-2019